﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CrystalDecisions.CrystalReports.Engine;

namespace Agenda_databinding
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        //al cargar Form2 se rellena el DataSet desde el archivo XML que está actualizado con los criterios de búsqueda empleados en Form1
        private void Form2_Load(object sender, EventArgs e)
        {
            //instanciar un objeto del tipo DataSet datosXml añadido al proyecto
            DataSet datos1 = new datosXml();
            //crear otro DataSet temporal para leer el archivo XML 
            DataSet datos1Temp = new DataSet();
            //leer el archivo XML usando el método ReadXml 
            datos1Temp.ReadXml(Application.StartupPath + "\\500empresas.xml");
            //copiar los datos XML desde el DataSet temporal al DataSet generado en el proyecto 
            datos1.Tables[0].Merge(datos1Temp.Tables[0]);

            //preparar el informe para su presentación instanciando un objeto CrystalReport1
            CrystalReport1 informeXml = new CrystalReport1();
            //propiedad DataSource del informe
            informeXml.SetDataSource(datos1.Tables[0]);
            //crystalReportViewer1.ToolPanelView = CrystalDecisions.Windows.Forms.ToolPanelViewType.None;
            //propiedad ReportSource del visor de informes
            crystalReportViewer1.ReportSource = informeXml;
        }
    }
}
