using System;
using System.Drawing;
using System.Diagnostics;
using System.Data;
using System.Collections;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Xml.Xsl;

using Agenda_databinding;

namespace Agenda_databinding
{

    public class Form1 : System.Windows.Forms.Form
    {
        [STAThread]
        static void Main()
        {
            System.Windows.Forms.Application.Run(new Form1());
        }

        //Variables declaradas a nivel de clase para poder usarlas desde
        //cualquier procedimiento o función
        private OleDbConnection conn = new OleDbConnection(); //conexión de tipo OleDb
        private string ruta; //almacena la ruta a la base de datos
        private OleDbDataAdapter adaptador; //DataAdapter: adaptador de datos
        private DataSet datos; //DataSet: conjunto de datos desconectados
        private OleDbCommandBuilder comando; //constructor de comandos para el DataAdapter
        private bool abierto = false; //para saber si ya está abierta la base de datos
        private bool buscando; //para saber si se están mostrando sólo los registros buscados
        private bool cambios = false; //para saber si hay cambios pendientes de guardar
        private BindingManagerBase enlaceBase; //administrador de los objetos de enlace a datos
        private Binding enlace; //objeto que enlaza control y datos

        #region  Código generado por el Diseñador de Windows Forms

        public Form1()
        {

            //El Diseñador de Windows Forms requiere esta llamada.
            InitializeComponent();

            //Agregar cualquier inicialización después de la llamada a InitializeComponent()

        }

        //Form reemplaza a Dispose para limpiar la lista de componentes.
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (!(components == null))
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        private System.ComponentModel.IContainer components;

        //NOTA: el Diseñador de Windows Forms requiere el siguiente procedimiento
        //Puede modificarse utilizando el Diseñador de Windows Forms.
        //No lo modifique con el editor de código.
        internal System.Windows.Forms.Label lbNombre;
        internal System.Windows.Forms.Label lbTel1;
        internal System.Windows.Forms.Label lbTel2;
        internal System.Windows.Forms.TextBox txNombre;
        internal System.Windows.Forms.TextBox txTel1;
        internal System.Windows.Forms.TextBox txTel2;
        internal System.Windows.Forms.Button btAvanzar;
        internal System.Windows.Forms.Button btRetroceder;
        internal System.Windows.Forms.Button btPrimero;
        internal System.Windows.Forms.Button btUltimo;
        internal System.Windows.Forms.GroupBox grupoNavegar;
        internal System.Windows.Forms.Button btInsertar;
        internal System.Windows.Forms.Button btActualizar;
        internal System.Windows.Forms.Button btSalir;
        internal System.Windows.Forms.GroupBox grupoEditar;
        internal System.Windows.Forms.Label lbRegistro;
        internal System.Windows.Forms.Button BtCargar;
        internal System.Windows.Forms.Label lbPrimera;
        internal System.Windows.Forms.ToolTip ToolTip1;
        internal System.Windows.Forms.Label lbSegunda;
        internal System.Windows.Forms.OpenFileDialog dlgFile;
        internal System.Windows.Forms.GroupBox grupoAvisos;
        internal System.Windows.Forms.Panel Panel1;
        internal System.Windows.Forms.Button btBorrar;
        internal System.Windows.Forms.Button btLimpiar;
        internal System.Windows.Forms.Button btIr2;
        internal System.Windows.Forms.Button btIr1;
        internal System.Windows.Forms.TextBox txBuscar;
        internal System.Windows.Forms.GroupBox grupoBuscar;
        internal System.Windows.Forms.Button BtTodos;
        internal System.Windows.Forms.Button BtInformeCR;
        internal System.Windows.Forms.Button BtInformeXSL;
        [System.Diagnostics.DebuggerStepThrough()]
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.lbNombre = new System.Windows.Forms.Label();
            this.lbTel1 = new System.Windows.Forms.Label();
            this.lbTel2 = new System.Windows.Forms.Label();
            this.lbPrimera = new System.Windows.Forms.Label();
            this.txNombre = new System.Windows.Forms.TextBox();
            this.txTel1 = new System.Windows.Forms.TextBox();
            this.txTel2 = new System.Windows.Forms.TextBox();
            this.BtCargar = new System.Windows.Forms.Button();
            this.btAvanzar = new System.Windows.Forms.Button();
            this.btRetroceder = new System.Windows.Forms.Button();
            this.btPrimero = new System.Windows.Forms.Button();
            this.btUltimo = new System.Windows.Forms.Button();
            this.grupoNavegar = new System.Windows.Forms.GroupBox();
            this.lbRegistro = new System.Windows.Forms.Label();
            this.btInsertar = new System.Windows.Forms.Button();
            this.btActualizar = new System.Windows.Forms.Button();
            this.btSalir = new System.Windows.Forms.Button();
            this.grupoEditar = new System.Windows.Forms.GroupBox();
            this.BtInformeXSL = new System.Windows.Forms.Button();
            this.BtInformeCR = new System.Windows.Forms.Button();
            this.btLimpiar = new System.Windows.Forms.Button();
            this.btBorrar = new System.Windows.Forms.Button();
            this.btIr2 = new System.Windows.Forms.Button();
            this.txBuscar = new System.Windows.Forms.TextBox();
            this.btIr1 = new System.Windows.Forms.Button();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.BtTodos = new System.Windows.Forms.Button();
            this.lbSegunda = new System.Windows.Forms.Label();
            this.dlgFile = new System.Windows.Forms.OpenFileDialog();
            this.grupoAvisos = new System.Windows.Forms.GroupBox();
            this.Panel1 = new System.Windows.Forms.Panel();
            this.grupoBuscar = new System.Windows.Forms.GroupBox();
            this.grupoNavegar.SuspendLayout();
            this.grupoEditar.SuspendLayout();
            this.grupoAvisos.SuspendLayout();
            this.grupoBuscar.SuspendLayout();
            this.SuspendLayout();
            // 
            // lbNombre
            // 
            this.lbNombre.AutoSize = true;
            this.lbNombre.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.lbNombre.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbNombre.Location = new System.Drawing.Point(61, 19);
            this.lbNombre.Name = "lbNombre";
            this.lbNombre.Size = new System.Drawing.Size(52, 13);
            this.lbNombre.TabIndex = 3;
            this.lbNombre.Text = "Nombre";
            this.lbNombre.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lbTel1
            // 
            this.lbTel1.AutoSize = true;
            this.lbTel1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.lbTel1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbTel1.Location = new System.Drawing.Point(47, 51);
            this.lbTel1.Name = "lbTel1";
            this.lbTel1.Size = new System.Drawing.Size(66, 13);
            this.lbTel1.TabIndex = 4;
            this.lbTel1.Text = "Teléfono 1";
            this.lbTel1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lbTel2
            // 
            this.lbTel2.AutoSize = true;
            this.lbTel2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbTel2.Location = new System.Drawing.Point(255, 51);
            this.lbTel2.Name = "lbTel2";
            this.lbTel2.Size = new System.Drawing.Size(66, 13);
            this.lbTel2.TabIndex = 5;
            this.lbTel2.Text = "Teléfono 2";
            this.lbTel2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lbPrimera
            // 
            this.lbPrimera.BackColor = System.Drawing.SystemColors.Control;
            this.lbPrimera.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.lbPrimera.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbPrimera.ForeColor = System.Drawing.Color.Blue;
            this.lbPrimera.Location = new System.Drawing.Point(9, 16);
            this.lbPrimera.Name = "lbPrimera";
            this.lbPrimera.Size = new System.Drawing.Size(439, 84);
            this.lbPrimera.TabIndex = 11;
            this.lbPrimera.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // txNombre
            // 
            this.txNombre.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txNombre.Location = new System.Drawing.Point(119, 16);
            this.txNombre.MaxLength = 150;
            this.txNombre.Name = "txNombre";
            this.txNombre.Size = new System.Drawing.Size(304, 21);
            this.txNombre.TabIndex = 0;
            // 
            // txTel1
            // 
            this.txTel1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txTel1.Location = new System.Drawing.Point(119, 48);
            this.txTel1.MaxLength = 9;
            this.txTel1.Name = "txTel1";
            this.txTel1.Size = new System.Drawing.Size(96, 21);
            this.txTel1.TabIndex = 1;
            // 
            // txTel2
            // 
            this.txTel2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txTel2.Location = new System.Drawing.Point(327, 48);
            this.txTel2.MaxLength = 9;
            this.txTel2.Name = "txTel2";
            this.txTel2.Size = new System.Drawing.Size(96, 21);
            this.txTel2.TabIndex = 2;
            // 
            // BtCargar
            // 
            this.BtCargar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.BtCargar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.BtCargar.Location = new System.Drawing.Point(24, 24);
            this.BtCargar.Name = "BtCargar";
            this.BtCargar.Size = new System.Drawing.Size(96, 24);
            this.BtCargar.TabIndex = 0;
            this.BtCargar.TabStop = false;
            this.BtCargar.Text = "Cargar datos";
            this.ToolTip1.SetToolTip(this.BtCargar, "Abrir la base de datos");
            this.BtCargar.Click += new System.EventHandler(this.BtCargar_Click);
            // 
            // btAvanzar
            // 
            this.btAvanzar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btAvanzar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btAvanzar.Location = new System.Drawing.Point(352, 24);
            this.btAvanzar.Name = "btAvanzar";
            this.btAvanzar.Size = new System.Drawing.Size(40, 24);
            this.btAvanzar.TabIndex = 4;
            this.btAvanzar.TabStop = false;
            this.btAvanzar.Text = ">";
            this.ToolTip1.SetToolTip(this.btAvanzar, "Avanzar");
            this.btAvanzar.Click += new System.EventHandler(this.BtAvanzar_Click);
            // 
            // btRetroceder
            // 
            this.btRetroceder.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btRetroceder.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btRetroceder.Location = new System.Drawing.Point(176, 24);
            this.btRetroceder.Name = "btRetroceder";
            this.btRetroceder.Size = new System.Drawing.Size(40, 24);
            this.btRetroceder.TabIndex = 2;
            this.btRetroceder.TabStop = false;
            this.btRetroceder.Text = "<";
            this.ToolTip1.SetToolTip(this.btRetroceder, "Retroceder");
            this.btRetroceder.Click += new System.EventHandler(this.BtRetroceder_Click);
            // 
            // btPrimero
            // 
            this.btPrimero.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btPrimero.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btPrimero.Location = new System.Drawing.Point(136, 24);
            this.btPrimero.Name = "btPrimero";
            this.btPrimero.Size = new System.Drawing.Size(40, 24);
            this.btPrimero.TabIndex = 1;
            this.btPrimero.TabStop = false;
            this.btPrimero.Text = "<<";
            this.ToolTip1.SetToolTip(this.btPrimero, "Primer registro");
            this.btPrimero.Click += new System.EventHandler(this.BtPrimero_Click);
            // 
            // btUltimo
            // 
            this.btUltimo.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btUltimo.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btUltimo.Location = new System.Drawing.Point(392, 24);
            this.btUltimo.Name = "btUltimo";
            this.btUltimo.Size = new System.Drawing.Size(40, 24);
            this.btUltimo.TabIndex = 5;
            this.btUltimo.TabStop = false;
            this.btUltimo.Text = ">>";
            this.ToolTip1.SetToolTip(this.btUltimo, "Ultimo registro");
            this.btUltimo.Click += new System.EventHandler(this.BtUltimo_Click);
            // 
            // grupoNavegar
            // 
            this.grupoNavegar.Controls.Add(this.btAvanzar);
            this.grupoNavegar.Controls.Add(this.btRetroceder);
            this.grupoNavegar.Controls.Add(this.btPrimero);
            this.grupoNavegar.Controls.Add(this.btUltimo);
            this.grupoNavegar.Controls.Add(this.lbRegistro);
            this.grupoNavegar.Controls.Add(this.BtCargar);
            this.grupoNavegar.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.grupoNavegar.Location = new System.Drawing.Point(8, 80);
            this.grupoNavegar.Name = "grupoNavegar";
            this.grupoNavegar.Size = new System.Drawing.Size(456, 64);
            this.grupoNavegar.TabIndex = 6;
            this.grupoNavegar.TabStop = false;
            this.grupoNavegar.Text = "Navegación por registros";
            // 
            // lbRegistro
            // 
            this.lbRegistro.BackColor = System.Drawing.Color.Navy;
            this.lbRegistro.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.lbRegistro.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.lbRegistro.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbRegistro.ForeColor = System.Drawing.Color.White;
            this.lbRegistro.Location = new System.Drawing.Point(208, 24);
            this.lbRegistro.Name = "lbRegistro";
            this.lbRegistro.Size = new System.Drawing.Size(152, 24);
            this.lbRegistro.TabIndex = 3;
            this.lbRegistro.Text = "Sin registros";
            this.lbRegistro.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // btInsertar
            // 
            this.btInsertar.AutoSize = true;
            this.btInsertar.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btInsertar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btInsertar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btInsertar.Location = new System.Drawing.Point(65, 28);
            this.btInsertar.Name = "btInsertar";
            this.btInsertar.Size = new System.Drawing.Size(65, 25);
            this.btInsertar.TabIndex = 1;
            this.btInsertar.TabStop = false;
            this.btInsertar.Text = "Insertar";
            this.ToolTip1.SetToolTip(this.btInsertar, "Insertar registro nuevo");
            this.btInsertar.Click += new System.EventHandler(this.BtInsertar_Click);
            // 
            // btActualizar
            // 
            this.btActualizar.AutoSize = true;
            this.btActualizar.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btActualizar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btActualizar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btActualizar.Location = new System.Drawing.Point(194, 28);
            this.btActualizar.Name = "btActualizar";
            this.btActualizar.Size = new System.Drawing.Size(75, 25);
            this.btActualizar.TabIndex = 3;
            this.btActualizar.TabStop = false;
            this.btActualizar.Text = "Actualizar";
            this.ToolTip1.SetToolTip(this.btActualizar, "Actualizar la base de datos con los cambios");
            this.btActualizar.Click += new System.EventHandler(this.BtActualizar_Click);
            // 
            // btSalir
            // 
            this.btSalir.AutoSize = true;
            this.btSalir.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btSalir.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btSalir.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btSalir.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btSalir.Location = new System.Drawing.Point(417, 28);
            this.btSalir.Name = "btSalir";
            this.btSalir.Size = new System.Drawing.Size(45, 25);
            this.btSalir.TabIndex = 9;
            this.btSalir.TabStop = false;
            this.btSalir.Text = "Salir";
            this.ToolTip1.SetToolTip(this.btSalir, "Salir del programa");
            this.btSalir.Click += new System.EventHandler(this.BtSalir_Click);
            // 
            // grupoEditar
            // 
            this.grupoEditar.Controls.Add(this.BtInformeXSL);
            this.grupoEditar.Controls.Add(this.BtInformeCR);
            this.grupoEditar.Controls.Add(this.btLimpiar);
            this.grupoEditar.Controls.Add(this.btSalir);
            this.grupoEditar.Controls.Add(this.btBorrar);
            this.grupoEditar.Controls.Add(this.btActualizar);
            this.grupoEditar.Controls.Add(this.btInsertar);
            this.grupoEditar.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.grupoEditar.Location = new System.Drawing.Point(11, 152);
            this.grupoEditar.Name = "grupoEditar";
            this.grupoEditar.Size = new System.Drawing.Size(470, 74);
            this.grupoEditar.TabIndex = 7;
            this.grupoEditar.TabStop = false;
            this.grupoEditar.Text = "Edición de registros";
            // 
            // BtInformeXSL
            // 
            this.BtInformeXSL.AutoSize = true;
            this.BtInformeXSL.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.BtInformeXSL.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.BtInformeXSL.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.BtInformeXSL.Location = new System.Drawing.Point(346, 28);
            this.BtInformeXSL.Name = "BtInformeXSL";
            this.BtInformeXSL.Size = new System.Drawing.Size(65, 25);
            this.BtInformeXSL.TabIndex = 11;
            this.BtInformeXSL.TabStop = false;
            this.BtInformeXSL.Text = "Informe";
            this.ToolTip1.SetToolTip(this.BtInformeXSL, "Actualizar la base de datos con los cambios");
            this.BtInformeXSL.Click += new System.EventHandler(this.BtInformeXSL_Click);
            // 
            // BtInformeCR
            // 
            this.BtInformeCR.AutoSize = true;
            this.BtInformeCR.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.BtInformeCR.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.BtInformeCR.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.BtInformeCR.Location = new System.Drawing.Point(275, 28);
            this.BtInformeCR.Name = "BtInformeCR";
            this.BtInformeCR.Size = new System.Drawing.Size(65, 25);
            this.BtInformeCR.TabIndex = 10;
            this.BtInformeCR.TabStop = false;
            this.BtInformeCR.Text = "Informe";
            this.ToolTip1.SetToolTip(this.BtInformeCR, "Actualizar la base de datos con los cambios");
            this.BtInformeCR.Click += new System.EventHandler(this.BtInforme_Click);
            // 
            // btLimpiar
            // 
            this.btLimpiar.AutoSize = true;
            this.btLimpiar.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btLimpiar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btLimpiar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btLimpiar.Location = new System.Drawing.Point(6, 28);
            this.btLimpiar.Name = "btLimpiar";
            this.btLimpiar.Size = new System.Drawing.Size(55, 25);
            this.btLimpiar.TabIndex = 0;
            this.btLimpiar.TabStop = false;
            this.btLimpiar.Text = "Nuevo";
            this.ToolTip1.SetToolTip(this.btLimpiar, "Limpiar los campos");
            this.btLimpiar.Click += new System.EventHandler(this.BtLimpiar_Click);
            // 
            // btBorrar
            // 
            this.btBorrar.AutoSize = true;
            this.btBorrar.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btBorrar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btBorrar.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btBorrar.Location = new System.Drawing.Point(134, 28);
            this.btBorrar.Name = "btBorrar";
            this.btBorrar.Size = new System.Drawing.Size(56, 25);
            this.btBorrar.TabIndex = 2;
            this.btBorrar.TabStop = false;
            this.btBorrar.Text = "Borrar";
            this.ToolTip1.SetToolTip(this.btBorrar, "Borrar registro actual");
            this.btBorrar.Click += new System.EventHandler(this.BtBorrar_Click);
            // 
            // btIr2
            // 
            this.btIr2.AutoSize = true;
            this.btIr2.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btIr2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btIr2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btIr2.Location = new System.Drawing.Point(240, 31);
            this.btIr2.Name = "btIr2";
            this.btIr2.Size = new System.Drawing.Size(189, 25);
            this.btIr2.TabIndex = 13;
            this.btIr2.TabStop = false;
            this.btIr2.Text = "En cualquier lugar de Nombre";
            this.ToolTip1.SetToolTip(this.btIr2, "Buscar el texto en cualquier lugar de Nombre");
            this.btIr2.Click += new System.EventHandler(this.BtIr2_Click);
            // 
            // txBuscar
            // 
            this.txBuscar.Font = new System.Drawing.Font("Verdana", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txBuscar.Location = new System.Drawing.Point(160, 31);
            this.txBuscar.MaxLength = 9;
            this.txBuscar.Name = "txBuscar";
            this.txBuscar.Size = new System.Drawing.Size(74, 23);
            this.txBuscar.TabIndex = 12;
            this.ToolTip1.SetToolTip(this.txBuscar, "Escribe letra/s para buscar por Nombre");
            // 
            // btIr1
            // 
            this.btIr1.AutoSize = true;
            this.btIr1.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.btIr1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btIr1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btIr1.Location = new System.Drawing.Point(24, 29);
            this.btIr1.Name = "btIr1";
            this.btIr1.Size = new System.Drawing.Size(130, 25);
            this.btIr1.TabIndex = 10;
            this.btIr1.TabStop = false;
            this.btIr1.Text = "Al inicio de Nombre";
            this.ToolTip1.SetToolTip(this.btIr1, "Buscar el texto al principio de Nombre");
            this.btIr1.Click += new System.EventHandler(this.BtIr1_Click);
            // 
            // ToolTip1
            // 
            this.ToolTip1.AutomaticDelay = 1000;
            // 
            // BtTodos
            // 
            this.BtTodos.AutoSize = true;
            this.BtTodos.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.BtTodos.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.BtTodos.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.BtTodos.Location = new System.Drawing.Point(143, 71);
            this.BtTodos.Name = "BtTodos";
            this.BtTodos.Size = new System.Drawing.Size(167, 25);
            this.BtTodos.TabIndex = 14;
            this.BtTodos.TabStop = false;
            this.BtTodos.Text = "Quitar filtros de búsqueda";
            this.ToolTip1.SetToolTip(this.BtTodos, "Volver a mostrar todos los registros");
            this.BtTodos.Click += new System.EventHandler(this.BtTodos_Click);
            // 
            // lbSegunda
            // 
            this.lbSegunda.BackColor = System.Drawing.SystemColors.Control;
            this.lbSegunda.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.lbSegunda.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lbSegunda.ForeColor = System.Drawing.Color.Blue;
            this.lbSegunda.Location = new System.Drawing.Point(9, 111);
            this.lbSegunda.Name = "lbSegunda";
            this.lbSegunda.Size = new System.Drawing.Size(439, 57);
            this.lbSegunda.TabIndex = 1;
            this.lbSegunda.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // grupoAvisos
            // 
            this.grupoAvisos.Controls.Add(this.Panel1);
            this.grupoAvisos.Controls.Add(this.lbSegunda);
            this.grupoAvisos.Controls.Add(this.lbPrimera);
            this.grupoAvisos.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.grupoAvisos.Location = new System.Drawing.Point(8, 371);
            this.grupoAvisos.Name = "grupoAvisos";
            this.grupoAvisos.Size = new System.Drawing.Size(456, 176);
            this.grupoAvisos.TabIndex = 10;
            this.grupoAvisos.TabStop = false;
            this.grupoAvisos.Text = "Avisos y ruta a la base de datos";
            // 
            // Panel1
            // 
            this.Panel1.BackColor = System.Drawing.SystemColors.Control;
            this.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.Panel1.Location = new System.Drawing.Point(16, 103);
            this.Panel1.Name = "Panel1";
            this.Panel1.Size = new System.Drawing.Size(424, 5);
            this.Panel1.TabIndex = 0;
            // 
            // grupoBuscar
            // 
            this.grupoBuscar.Controls.Add(this.BtTodos);
            this.grupoBuscar.Controls.Add(this.btIr2);
            this.grupoBuscar.Controls.Add(this.btIr1);
            this.grupoBuscar.Controls.Add(this.txBuscar);
            this.grupoBuscar.Location = new System.Drawing.Point(12, 241);
            this.grupoBuscar.Name = "grupoBuscar";
            this.grupoBuscar.Size = new System.Drawing.Size(452, 113);
            this.grupoBuscar.TabIndex = 11;
            this.grupoBuscar.TabStop = false;
            this.grupoBuscar.Text = "Buscar";
            // 
            // Form1
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
            this.CancelButton = this.btSalir;
            this.ClientSize = new System.Drawing.Size(567, 563);
            this.Controls.Add(this.grupoBuscar);
            this.Controls.Add(this.txTel2);
            this.Controls.Add(this.txTel1);
            this.Controls.Add(this.txNombre);
            this.Controls.Add(this.lbTel2);
            this.Controls.Add(this.lbTel1);
            this.Controls.Add(this.lbNombre);
            this.Controls.Add(this.grupoNavegar);
            this.Controls.Add(this.grupoEditar);
            this.Controls.Add(this.grupoAvisos);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "DataBinding C#";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.grupoNavegar.ResumeLayout(false);
            this.grupoEditar.ResumeLayout(false);
            this.grupoEditar.PerformLayout();
            this.grupoAvisos.ResumeLayout(false);
            this.grupoBuscar.ResumeLayout(false);
            this.grupoBuscar.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

        //Al cargar el formulario
        private void Form1_Load(System.Object sender, System.EventArgs e)
        {
            //Texto inicial de las etiquetas
            lbPrimera.Text = "Pulsa en \"Cargar datos\" para conectarte a la base de datos.\nElige la base de datos en el cuadro de diálogo.\nElige una BD de Access con 3 campos:\nNombre, Teléfono1 Y Teléfono2.";
            lbSegunda.Text = "Desconectado. Conjunto de datos vacío.";
            //Altura inicial del separador Panel1
            Panel1.Height = 5;
            //botes de Informes deshabilitados
            this.BtInformeCR.Enabled = false;
            this.BtInformeXSL.Enabled = false;

            //cargar los datos  al mostrar el formulario en lugar de hacerlo desde el botón Cargar datos
            //CargarDatos();
        }

        void CargarDatos()
        {
            try
            {
                //ruta a la base de datos en la carpeta del ensamblado
                ruta = Application.StartupPath + "\\500empresas.mdb";    
                // para usar BD de Access con extensión accdb (también sirve para .mdb) hay que recurrir a Provider=Microsoft.ACE.OLEDB.12.0
                    conn.ConnectionString = "Provider=Microsoft.ACE.OLEDB.16.0;Data Source=" + ruta + ";User Id=admin;Password=;";
                // para usar BD de Access con extensión mdb más antigua hay que recurrir a Provider=Microsoft.Jet.OLEDB.4.0
                //con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & ruta & ";User Id=admin;Password=;"

                //MessageBox.Show("ConnectionString: " + conn.ConnectionString);

                    //DataAdapter: objeto que hace de puente entre la base de datos y el DataSet o conjunto de datos
                    adaptador = new OleDbDataAdapter("SELECT * FROM AgendaTb ORDER BY Nombre", conn);
                    //DataAdapter puede contener sentencias SQL y objetos Command
                    comando = new OleDbCommandBuilder(adaptador);
                    //DataSet: contiene una copia de la base de datos, en esquema XML, independiente del proveedor, con sus elementos tablas y relaciones. Es el verdadero almacén de datos desconectados: actuamos sobre el DataSet desconectado y el DataAdapter se conecta para volcar los datos entre base de datos y DataSet, en ambos sentidos
                    datos = new DataSet();

                    //Abrir la conexión, el DataAdapter llena el DataSet, cerrar la conexión. DataAdapter se encarga de abrir y cerrar la conexión
                    conn.Open();
                    adaptador.Fill(datos, "AgendaTb");
                    conn.Close();

                    //Para enlazar controles del formulario con el DataSet usamos DataBinding; al objeto Binding le pasamos la propiedad del control que se debe enlazar, el DataSet y la tabla o columna. El objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido, con el método Add()
                    enlace = new Binding("Text", datos, "AgendaTb.Nombre");
                    txNombre.DataBindings.Add(enlace);
                    enlace = null;
                    enlace = new Binding("Text", datos, "AgendaTb.Teléfono1");
                    txTel1.DataBindings.Add(enlace);
                    enlace = null;
                    enlace = new Binding("Text", datos, "AgendaTb.Teléfono2");
                    txTel2.DataBindings.Add(enlace);
                    enlace = null;

                    //Para enlazar controles de un  formulario con un origen de datos (por ejemplo DataSet) se usa la propiedad DataBinding que obtiene los enlaces de datos del control. La propiedad DataBinding se utiliza para obtener acceso al ControlBindingsCollection que representa a la colección de enlaces de datos de un control. Al objeto Binding le pasamos  la propiedad del control que se debe enlazar, el oriegen de datos (DataSet) y la tabla o columna. Al enlazar un control a datos usando DataBindings se puede enlazar cualquier propiedad de un control a la propiedad de un objeto. El objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido utilizando el método Add().
                    //
                    //Al objeto BindingManagerBase le pasamos el DataSet y la tabla desde el objeto BindingContext del formulario. Cada formulario tiene al menos 1 BindingContext y por cada BindingContext existe 1 objeto CurrencyManager o PropertyManager. BindingContext administra los objetos BindingManagerBase del formulario. BindingManagerBase puede devolver una propiedad única o una lista:
                    //- si devuelve una propiedad (por ejemplo un control TextBox), BindingManagerBase devuelve un objeto PropertyManager
                    //- si devuelve una lista desde controles que implementen IList o IBindingList (ArrayList, ComboBox, ListBox, TreeNode, DataView, etc.), BindingManagerBase devuelve un objeto CurrencyManager.
                    //
                    //Para manejar la navegación entre los registros podemos utilizar el BindingContext que administra la colección de objetos BindingManagerBase para cualquier objeto que se herede de la clase Control. El BindigManagerBase permite la sincronización de controles con enlace al mismo origen. La Clase CurrencyManager que administra la lista de objetos Binding se hereda de la clase BindingManagerBase y mantiene  sincronizados los controles señalando el elemento actual de la lista. Normalmente, se utiliza el objeto BindingContext de la clase Form con el fin de devolver objetos BindingManagerBase para los controles con enlace a datos del formulario.

                    this.enlaceBase = this.BindingContext[datos, "AgendaTb"];

                    //mostrar información
                    lbSegunda.Text = "BD: " + ruta;
                    //Procedimiento que informa sobre el nº de registros más abajo
                    VerCuenta();
                    //Para saber que la base de datos ya está cargada
                    abierto = true;
                    //Para saber que NO se están buscando registros, SÍ se muestran todos
                    buscando = false;
                }
                            catch (Exception pollo)
            {
                lbPrimera.Text = pollo.Message.ToUpper();
            }

        }

        private void BtCargar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta, simplemente informar
            if (abierto == true)
            {
                lbPrimera.Text = "La base de datos ya está cargada en el DataSet";
            }
            //Si la base de datos NO está abierta
            if (abierto == false)
            {
                try
                {
                    //Cuadro de diálogo para elegir la base de datos
                    dlgFile = new OpenFileDialog();
                    dlgFile.Filter = "Base de datos Agenda (*.mdb)|*.mdb";
                    dlgFile.Title = "Selecciona la base de datos Agenda";
                    //Si el diálogo devuelve OK
                    if (dlgFile.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    {
                        //Nombre del archivo elegido, con su ruta completa, equivale a la base de datos
                        ruta = dlgFile.FileName;

                        // para usar BD de Access con extensión accdb (también sirve para .mdb) hay que recurrir a Provider=Microsoft.ACE.OLEDB.12.0
                        conn.ConnectionString = "Provider=Microsoft.ACE.OLEDB.16.0;Data Source=" + ruta + ";User Id=admin;Password=;";
                        // para usar BD de Access con extensión mdb más antigua hay que recurrir a Provider=Microsoft.Jet.OLEDB.4.0
                        //con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & ruta & ";User Id=admin;Password=;"

                        //DataAdapter: objeto que hace de puente entre la base de datos y el DataSet o conjunto de datos
                        adaptador = new OleDbDataAdapter("SELECT * FROM AgendaTb ORDER BY Nombre", conn);
                        //DataAdapter puede contener sentencias SQL y objetos Command
                        comando = new OleDbCommandBuilder(adaptador);
                        //DataSet: contiene una copia de la base de datos, en esquema XML, independiente del proveedor, con sus elementos tablas y relaciones. Es el verdadero almacén de datos desconectados: actuamos sobre el DataSet desconectado y el DataAdapter se conecta para volcar los datos entre base de datos y DataSet, en ambos sentidos
                        datos = new DataSet();

                        //Abrir la conexión, el DataAdapter llena el DataSet, cerrar la conexión. DataAdapter se encarga de abrir y cerrar la conexión
                        //conn.Open();
                        adaptador.Fill(datos, "AgendaTb");
                        //conn.Close();

                        //MessageBox.Show( datos.Tables[0].Columns[0].ToString() +  "\n" + datos.Tables[0].Columns[1].ToString() + "\n " + datos.Tables[0].Columns[2].ToString());

                        //Para enlazar controles del formulario con el DataSet usamos DataBinding; al objeto Binding le pasamos la propiedad del control que se debe enlazar, el DataSet y la tabla o columna. El objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido, con el método Add()
                        enlace = new Binding("Text", datos, "AgendaTb.Nombre");
                        txNombre.DataBindings.Add(enlace);
                        enlace = null;
                        enlace = new Binding("Text", datos, "AgendaTb.Teléfono1");
                        txTel1.DataBindings.Add(enlace);
                        enlace = null;
                        enlace = new Binding("Text", datos, "AgendaTb.Teléfono2");
                        txTel2.DataBindings.Add(enlace);
                        enlace = null;

                        //Para enlazar controles de un  formulario con un origen de datos (por ejemplo DataSet) se usa la propiedad DataBinding que obtiene los enlaces de datos del control. La propiedad DataBinding se utiliza para obtener acceso al ControlBindingsCollection que representa a la colección de enlaces de datos de un control. Al objeto Binding le pasamos  la propiedad del control que se debe enlazar, el oriegen de datos (DataSet) y la tabla o columna. Al enlazar un control a datos usando DataBindings se puede enlazar cualquier propiedad de un control a la propiedad de un objeto. El objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido utilizando el método Add().
                        //
                        //Al objeto BindingManagerBase le pasamos el DataSet y la tabla desde el objeto BindingContext del formulario. Cada formulario tiene al menos 1 BindingContext y por cada BindingContext existe 1 objeto CurrencyManager o PropertyManager. BindingContext administra los objetos BindingManagerBase del formulario. BindingManagerBase puede devolver una propiedad única o una lista:
                        //- si devuelve una propiedad (por ejemplo un control TextBox), BindingManagerBase devuelve un objeto PropertyManager
                        //- si devuelve una lista desde controles que implementen IList o IBindingList (ArrayList, ComboBox, ListBox, TreeNode, DataView, etc.), BindingManagerBase devuelve un objeto CurrencyManager.
                        //
                        //Para manejar la navegación entre los registros podemos utilizar el BindingContext que administra la colección de objetos BindingManagerBase para cualquier objeto que se herede de la clase Control. El BindigManagerBase permite la sincronización de controles con enlace al mismo origen. La Clase CurrencyManager que administra la lista de objetos Binding se hereda de la clase BindingManagerBase y mantiene  sincronizados los controles señalando el elemento actual de la lista. Normalmente, se utiliza el objeto BindingContext de la clase Form con el fin de devolver objetos BindingManagerBase para los controles con enlace a datos del formulario.

                        this.enlaceBase = this.BindingContext[datos, "AgendaTb"];

                        //mostrar información
                        lbSegunda.Text = "BD: " + ruta;
                        //Procedimiento que informa sobre el nº de registros más abajo
                        VerCuenta();
                        //Para saber que la base de datos ya está cargada
                        abierto = true;
                        //Para saber que NO se están buscando registros, SÍ se muestran todos
                        buscando = false;
                        //habilitar botones de ver Informes
                        this.BtInformeCR.Enabled = true;
                        this.BtInformeXSL.Enabled = true;

                        //this.crystalReportViewer1.ReportSource = "CrystalReport11 [Agenda_databinding.CrystalReport1]";
                        //this.crystalReportViewer1.RefreshReport();
                    }
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
        }

        //Mostrar el nº de registro actual y el total de registros en la etiqueta lbRegistro
        private void VerCuenta()
        {
            lbRegistro.Text = "Registro " + (enlaceBase.Position + 1).ToString() + " de " + (this.enlaceBase.Count).ToString();
            //lbRegistro.Text = "Registro " + System.Convert.ToString(this.enlaceBase.Position + 1) + " de " + System.Convert.ToString(this.enlaceBase.Count);
            lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
        }

        //Gracias al enlace automático entre controles y datos (DataBinding) es muy sencillo navegar entre registros y se necesita poco código. El objeto enlaceBase (BindingManagerBase) se encarga de actualizar de manera automática el control con los datos de la fila actual

        //ir al registro siguiente
        private void BtAvanzar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                try
                {
                    //Si ya estamos en el último registro
                    if (this.enlaceBase.Position == this.enlaceBase.Count - 1)
                    {
                        //lbPrimera.Text = "Ya estás en el último registro de la tabla";
                        lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
                    }
                    else
                    {
                        //avanzar un registro
                        this.enlaceBase.Position++;
                        VerCuenta();
                    }
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }

        }

        //ir al registro anterior
        private void BtRetroceder_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                try
                {
                    //Si ya estamos en el primer registro
                    if (this.enlaceBase.Position == 0)
                    {
                        //lbPrimera.Text = "Ya estás en el primer registro de la tabla";
                        lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
                        return;
                    }
                    else
                    {
                        //retroceder un registro
                        this.enlaceBase.Position--;
                        VerCuenta();
                    }
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //ir al primer registro
        private void BtPrimero_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                try
                {
                    //Si ya estamos en el primer registro
                    if (this.enlaceBase.Position == 0)
                    {
                        //lbPrimera.Text = "Ya estás en el primer registro de la tabla";
                        lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\""; return;
                    }
                    else
                    {
                        //ir al primer registro
                        this.enlaceBase.Position = 0;
                        VerCuenta();
                    }
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //ir al último registro
        private void BtUltimo_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                try
                {
                    //Si ya estamos en el último registro
                    if (this.enlaceBase.Position == this.enlaceBase.Count - 1)
                    {
                        //lbPrimera.Text = "Ya estás en el último registro de la tabla";
                        lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\""; return;
                    }
                    else
                    {
                        //ir al último registro
                        this.enlaceBase.Position = this.enlaceBase.Count - 1;
                        VerCuenta();
                    }
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //Para borrar un registro
        private void BtBorrar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                try
                {
                    //Borrar el registro que se corresponde con la posición actual
                    this.enlaceBase.RemoveAt(this.enlaceBase.Position);
                    lbPrimera.Text = "Se ha eliminado un registro.\nPulsa actualizar si deseas guardar los cambios.";
                    cambios = true;
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //Para vaciar los campos de texto
        private void BtLimpiar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                txNombre.Text = "";
                txTel1.Text = "";
                txTel2.Text = "";
                txNombre.Focus();
                lbPrimera.Text = "Se han vaciado los cuadros de texto.\nPara añadir un registro, rellénalos\ncon los datos nuevos y pulsa \"Insertar\"";
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //Para añadir un registro
        private void BtInsertar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                //crear una nueva fila en la tabla
                DataRow fila = this.datos.Tables["AgendaTb"].NewRow();
                try
                {
                    //rellenar los campos de la fila nueva
                    fila["Nombre"] = txNombre.Text;
                    fila["Teléfono1"] = txTel1.Text;
                    fila["Teléfono2"] = txTel2.Text;
                    lbPrimera.Text = "Se ha insertado un registro nuevo.\nPulsa actualizar si deseas guardar los cambios.";
                    //añadir la nueva fila a la tabla
                    this.datos.Tables["AgendaTb"].Rows.Add(fila);
                    cambios = true;
                }
                catch (Exception pollo)
                {
                    lbPrimera.Text = pollo.Message.ToUpper();
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        //Para actualizar el adaptador de datos (DataAdapter) con los cambios hechos en el DataSet
        private void BtActualizar_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos está abierta
            if (abierto == true)
            {
                //Si ha habido cambios en el DataSet desde la última actualización
                //if (datos.HasChanges())
                if (cambios == true)
                {
                    try
                    {
                        //Actualizar DataAdapter, se pueden pasar parámetros:
                        // - (datos as dataset, "tabla" as string)
                        // - (datos.tables("tabla") as dataset) --> usado aquí
                        this.adaptador.Update(this.datos.Tables["AgendaTb"]);
                        //Vaciar el DataSet: conserva los datos de tablas y registros y si no se limpia acumula las operaciones sucesivas de modificación de filas
                        this.datos.Clear();
                        //Volver a llenar el DataSet desde el DataAdapter ya modificado
                        this.adaptador.Fill(datos, "AgendaTb");
                        //Actualizar la etiqueta lbRegistro
                        VerCuenta();
                        //Indicador de cambios pendientes a false
                        cambios = false;
                        lbPrimera.Text = "Base de datos actualizada con los cambios realizados";
                    }
                    catch (Exception pollo)
                    {
                        lbPrimera.Text = pollo.Message.ToUpper();
                    }
                }
                else
                {
                    //Si NO ha habido cambios en el DataSet desde la última actualización
                    lbPrimera.Text = "No hay cambios pendientes de actualizar";
                }
            }
            //Si la base de datos NO está abierta
            else
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
            }
        }

        private void BtSalir_Click(System.Object sender, System.EventArgs e)
        {
            //Si la base de datos NO está abierta
            if (abierto == false)
            {
                //Cerrar el formulario
                this.Close();
            }
            if (abierto == true)
            {
                //si NO ha habido cambios en el DataSet desde la última actualización
                if (cambios == false)
                {
                    //Cerrar el formulario
                    this.Close();
                }
                //Si la base de datos está abierta y si ha habido cambios en el DataSet desde la última actualización
                if (cambios == true)
                {
                    if (MessageBox.Show("Hay cambios pendientes de guardar.\nPulsa en \"Cancelar\" para volver al programa.\nPulsa en \"Aceptar\" para salir sin guardar", "Cambios sin guardar", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) == DialogResult.OK)
                    {
                        this.Close();
                    }
                }
            }
        }

        private void BtIr1_Click(object sender, EventArgs e)
        {
            //Si la base de datos NO está abierta
            if (abierto == false)
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
                return;
            }
            //si hay algo escrito en TxBuscar
            if (!(txBuscar.Text == ""))
            {
                lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
                //vaciar enlaces anteriores de los cuadros de texto
                txNombre.DataBindings.Clear();
                txTel1.DataBindings.Clear();
                txTel2.DataBindings.Clear();

                //crear nuevos ojetos OleDbDataAdapter y OleDbCommandBuilder con sentencia SQL diferente. Al principio del Nombre
                adaptador = new OleDbDataAdapter("SELECT * FROM AgendaTb WHERE Nombre LIKE '" + this.txBuscar.Text + "%'", conn);
                comando = new OleDbCommandBuilder(adaptador);
                //vaciar el DataSet y rellenarlo de nuevo
                datos.Clear();
                adaptador.Fill(datos, "AgendaTb");

                //enlazar controles y DataSet con DataBinding
                enlace = new Binding("Text", datos, "AgendaTb.Nombre");
                txNombre.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono1");
                txTel1.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono2");
                txTel2.DataBindings.Add(enlace);
                enlace = null;
                this.enlaceBase = this.BindingContext[datos, "AgendaTb"];

                //mostrar el registro actual y el total de registros
                VerCuenta();
                //Para saber que SÍ se están buscando registros, NO se muestran todos
                buscando = true;
            }
            //si txBuscar está vacío
            else
            {
                lbPrimera.Text = "El cuadro de búsqueda está vacío.";
                return;
            }
        }

        private void BtIr2_Click(object sender, EventArgs e)
        {
            //Si la base de datos NO está abierta
            if (abierto == false)
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
                return;
            }
            //si hay algo escrito en TxBuscar
            if (!(txBuscar.Text == ""))
            {
                lbPrimera.Text = "Base de datos cargada en el conjunto de datos,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
                //vaciar enlaces anteriores de los cuadros de texto
                txNombre.DataBindings.Clear();
                txTel1.DataBindings.Clear();
                txTel2.DataBindings.Clear();

                //crear nuevos ojetos OleDbDataAdapter y OleDbCommandBuilder con sentencia SQL diferente. En cualquier lugar del nombre
                adaptador = new OleDbDataAdapter("SELECT * FROM AgendaTb WHERE Nombre LIKE '%" + this.txBuscar.Text + "%'", conn);
                comando = new OleDbCommandBuilder(adaptador);
                //vaciar el DataSet y rellenarlo de nuevo
                datos.Clear();
                adaptador.Fill(datos, "AgendaTb");
                //enlazar controles y DataSet con DataBinding
                enlace = new Binding("Text", datos, "AgendaTb.Nombre");
                txNombre.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono1");
                txTel1.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono2");
                txTel2.DataBindings.Add(enlace);
                enlace = null;
                this.enlaceBase = this.BindingContext[datos, "AgendaTb"];

                //mostrar el registro actual y el total de registros
                VerCuenta();
                //Para saber que SÍ se están buscando registros, NO se muestran todos
                buscando = true;
            }
            //si txBuscar está vacío
            else
            {
                lbPrimera.Text = "El cuadro de búsqueda está vacío.";
                return;
            }
        }

        //quitar los filtros de búsqueda
        private void BtTodos_Click(object sender, EventArgs e)
        {
            //Si la base de datos NO está abierta
            if (abierto == false)
            {
                lbPrimera.Text = "Primero has de cargar la base de datos";
                return;
            }
            //Si la base de datos SÍ está abierta y hay filtro de búsqueda aplicado a los registros
            else if ((abierto == true) & (buscando == true))
            {
                //mostrar información en la etiqueta lbPrimera
                lbPrimera.Text = "Base de datos cargada en el DataSet,\nusando DataBinding: Enlace de datos a controles.\nPara insertar un registro nuevo, pulsa \"Nuevo\",\nescribe los datos y pulsa \"Insertar\"";
                //vaciar enlaces anteriores de los cuadros de texto               
                txNombre.DataBindings.Clear();
                txTel1.DataBindings.Clear();
                txTel2.DataBindings.Clear();

                //DataAdapter: objeto que hace de puente entre la base de datos y el DataSet
                adaptador = new OleDbDataAdapter("SELECT * FROM AgendaTb ORDER BY Nombre", conn);
                //DataAdapter puede contener sentencias SQL y objetos Command
                comando = new OleDbCommandBuilder(adaptador);
                //DataSet: contiene una copia de la base de datos, en esquema XML, independiente del proveedor, con sus elementos tablas y relaciones. Es el verdadero almacén de datos desconectados: actuamos sobre el DataSet desconectado y el DataAdapter se conecta para volcar los datos entre base de datos y DataSet, en ambos sentidos
                datos = new DataSet();

                //Abrir la conexión, el DataAdapter llena el DataSet, cerrar la conexión. DataAdapter se encarga de abrir y cerrar la conexión
                //conn.Open();
                adaptador.Fill(datos, "AgendaTb");
                //conn.Close();

                //Para enlazar controles del formulario con el DataSet usamos DataBinding; al objeto Binding le pasamos la propiedad del control que se debe enlazar, el DataSet y la tabla o columna. Después, el objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido con el método Add()
                enlace = new Binding("Text", datos, "AgendaTb.Nombre");
                txNombre.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono1");
                txTel1.DataBindings.Add(enlace);
                enlace = null;
                enlace = new Binding("Text", datos, "AgendaTb.Teléfono2");
                txTel2.DataBindings.Add(enlace);
                enlace = null;

                //Para enlazar controles de un  formulario con un origen de datos (por ejemplo DataSet) se usa la propiedad DataBinding que obtiene los enlaces de datos del control. La propiedad DataBinding se utiliza para obtener acceso al ControlBindingsCollection que representa a la colección de enlaces de datos de un control. Al objeto Binding le pasamos  la propiedad del control que se debe enlazar, el oriegen de datos (DataSet) y la tabla o columna. Al enlazar un control a datos usando DataBindings se puede enlazar cualquier propiedad de un control a la propiedad de un objeto. El objeto Binding se añade a la colección de enlaces de datos (ControlBindingsCollection) del control elegido utilizando el método Add().

                //Al objeto BindingManagerBase le pasamos el DataSet y la tabla desde el objeto BindingContext del formulario. Cada formulario tiene al menos 1 BindingContext y por cada BindingContext existe 1 objeto CurrencyManager o PropertyManager. BindingContext administra los objetos BindingManagerBase del formulario. BindingManagerBase puede devolver una propiedad única o una lista:
                //- si devuelve una propiedad (por ejemplo un control TextBox), BindingManagerBase devuelve un objeto PropertyManager
                //- si devuelve una lista desde controles que implementen IList o IBindingList (ArrayList, ComboBox, ListBox, TreeNode, DataView, etc.), BindingManagerBase devuelve un objeto CurrencyManager.

                //Para manejar la navegación entre los registros podemos utilizar el BindingContext que administra la colección de objetos BindingManagerBase para cualquier objeto que se herede de la clase Control. El BindigManagerBase permite la sincronización de controles con enlace al mismo origen. La Clase CurrencyManager que administra la lista de objetos Binding se hereda de la clase BindingManagerBase y mantiene  sincronizados los controles señalando el elemento actual de la lista. Normalmente, se utiliza el objeto BindingContext de la clase Form con el fin de devolver objetos BindingManagerBase para los controles con enlace a datos del formulario.

                this.enlaceBase = this.BindingContext[datos, "AgendaTb"];
                this.txBuscar.Text = "";

                //mostrar información
                lbSegunda.Text = "BD: " + ruta;
                VerCuenta();
                //Para saber que NO se están buscando registros, se muestran todos
                buscando = false;
            }
            //Si la base de datos NO está abierta o NO hay filtro de búsqueda aplicado a los registros
            else
            {
                lbPrimera.Text = "No hay filtros de búsqueda aplicados.\nSe están mostrando todos los registros";
                return;
            }
        }

        //mostrar el segundo formulario con el informe Crystal Reports
        private void BtInforme_Click(object sender, EventArgs e)
        {
            try
            {
                XmlUpdate();

                Form2 informe = new Form2();
                informe.Show();
            }
            catch (Exception pollo)
            {
                MessageBox.Show(pollo.StackTrace.ToUpper(), "Aviso", MessageBoxButtons.OK);
            }
        }

        void XmlUpdate()
        {
            //Actualizar DataAdapter, se pueden pasar parámetros:
            // - (datos as dataset, "tabla" as string)
            // - (datos.tables("tabla") as dataset) --> usado aquí
            this.adaptador.Update(this.datos.Tables["AgendaTb"]);
            //Vaciar el DataSet: conserva los datos de tablas y registros y si no se limpia acumula las operaciones sucesivas de modificación de filas
            this.datos.Clear();
            //Volver a llenar el DataSet desde el DataAdapter ya modificado
            this.adaptador.Fill(datos, "AgendaTb");
            //actualizar el archivo XML
            this.datos.WriteXml("500empresas.xml");
        }

        private void BtInformeXSL_Click(object sender, EventArgs e)
        {
            try
            {
                XmlUpdate();

                string ruta1 = "500empresas.xsl";
                string ruta2 = "500empresas.xml";
                string ruta3 = "500empresas.html";
                XslCompiledTransform xslt = new XslCompiledTransform();
                xslt.Load(ruta1);
                xslt.Transform(ruta2, ruta3);

                //ProcessStartInfo se utiliza para iniciar procesos
                ProcessStartInfo abrirDoc = new ProcessStartInfo();
                abrirDoc.FileName = Application.StartupPath + "\\500empresas.html";
                //modo de apertura de archivo (también puede ser edit, print...)
                abrirDoc.Verb = "open";
                //abrir en ventana normal
                abrirDoc.WindowStyle = ProcessWindowStyle.Normal;
                //Abrir el archivo mediante su programa asociado en Windows
                Process.Start(abrirDoc);

            }
            catch (Exception pollo)
            {
                MessageBox.Show(pollo.StackTrace.ToUpper(), "Aviso", MessageBoxButtons.OK);
            }
        }
    
    }

}
